"""
Methods for Exercises 2
Spring School on Scientific Computing

"""

import numpy as np



def newton(f,df,x0,maxiter,tol):
    """
    Solves f(x) = 0 using Newton's method
    Input:
        f: function
        df: derivative of f (also as a function)
        x0: float, starting value
        maxiter: int, maximum iteration number
        tol: float, stopping criterion
    Output:
        xn: float, solution
        iter: number of iterations needed
        fun_values: Array of function values (Ex 2.1(c))
    """
     
    # Initialisation   
    xn = x0
    fun = f(xn)
    iter = 0
        
    fun_values = np.array([fun])
    
    # TO DO: Implement Newton
    # While ...

        
       
    return xn, iter, fun_values


# The bisection algorithm is already implemented

def bisection(f,a,b,tol):
    """
    This method solves a system f(x) = 0 
    using bisection
    Input:
        f: function
        a: float, left interval limit 
        b: float, right interval limit
        tol: float, stopping criterion
    Output:
        x_n: float, solution
        it: number of iterations
        fun_values: Array of function values (Ex 2.2(b))
        
    """
        
    
    l,r = a,b
    fun_l, fun_r = f(l), f(r)
    it = 1
    
    if fun_l*fun_r >= 0:
        print('Error in bisection: Function values need to have different signs')
        return
    
    fun_values = np.array([])  # Exercise 2.2 (b)
    
    c = (l+r)/2
    
    while np.abs(f(c)) >= tol:
        
        if fun_l*f(c) < 0:
            r = c
        else:
            l = c
            
        fun_l, fun_r = f(l), f(r)
        c = (l+r)/2
       
        fun_values = np.append(fun_values,f(c))
        
        it += 1
    
    return c, it, fun_values

